package com.qmth.themis.business.service;

import com.qmth.themis.common.util.Result;

/**
 * @Description: mq 服务类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/6/28
 */
public interface ProducerServer {

    /**
     * 同步消息
     *
     * @param topic
     * @param tags
     * @param msg
     * @return
     */
    Result syncMsg(String topic, String tags, Object msg);

    /**
     * 异步消息
     *
     * @param topic
     * @param tags
     * @param msg
     * @return
     */
    Result asyncMsg(String topic, String tags, Object msg);

    /**
     * 单向消息
     *
     * @param topic
     * @param tags
     * @param msg
     * @return
     */
    Result sendOneWay(String topic, String tags, Object msg);

    /**
     * 事务消息
     *
     * @param topic
     * @param tags
     * @param msg
     * @return
     */
    Result sendMsgTran(String topic, String tags, Object msg);
}
