package com.qmth.themis.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.google.gson.Gson;
import com.qmth.themis.business.dao.TBSessionMapper;
import com.qmth.themis.business.entity.TBSession;
import com.qmth.themis.business.service.TBSessionService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Objects;

/**
 * @Description: 会话信息 服务实现类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/6/25
 */
@Service
public class TBSessionServiceImpl extends ServiceImpl<TBSessionMapper, TBSession> implements TBSessionService {

    /**
     * 保存session信息
     *
     * @param tbSession
     * @return
     */
    @Override
    public boolean saveSessionInfo(TBSession tbSession) {
        QueryWrapper<TBSession> sqw = new QueryWrapper<>();
        sqw.lambda().eq(TBSession::getId, tbSession.getId()).eq(TBSession::getType, tbSession.getType()).eq(TBSession::getPlatform, tbSession.getPlatform());
        TBSession tbSessionDb = this.getOne(sqw);
        if (Objects.isNull(tbSessionDb)) {
            Gson gson = new Gson();
            tbSessionDb = gson.fromJson(gson.toJson(tbSession), TBSession.class);
        } else {
            tbSessionDb.setDeviceId(tbSession.getDeviceId());
            tbSessionDb.setAccessToken(tbSession.getAccessToken());
            tbSessionDb.setLastAccessIp(tbSession.getLastAccessIp());
            tbSessionDb.setLastAccessTime(new Date());
            tbSessionDb.setUpdateTime(new Date());
            tbSessionDb.setExpireTime(tbSession.getExpireTime());
        }
        this.saveOrUpdate(tbSessionDb);
        return true;
    }
}
